package nl.uvt.locator;

import nu.xom.*;
import org.apache.log4j.*;

public class LocatorInfo {
	String linkTitle;
	String linkIssn;
	String linkUrl;
	int rank;
	String linkMethod;
	String linkPublisher;
	String generatedUrl;

	protected Logger logger;

	LocatorInfo(){
		logger = Logger.getLogger(Locator.class);
		linkTitle = "";
		linkIssn = "";
		linkUrl = "";
		rank = 10;  // quite bad ranking
		generatedUrl = "";
		linkPublisher="";
		linkMethod = "";
	}

	protected String getValue( Node node, String val ){
		Nodes nodes = node.query( val );
		if ( nodes.size() > 0 ){
			return nodes.get(0).getValue();
		}
		else
			return "";
	}

	protected String[] getValues( Node node, String val ){
		Nodes nodes = node.query( val );
		if ( nodes.size() > 0 ){
			String[] result = new String[nodes.size()];
			for ( int i=0; i < nodes.size(); ++i )
				result[i] = nodes.get(i).getValue();
			return result;
		}
		else
			return null;
	}

	protected Node getXmlValue( Node node, String val ){
		Nodes nodes = node.query( val );
		if ( nodes.size() > 0 ){
			return nodes.get(0).copy();
		}
		else
			return null;
	}

	public boolean inRange( QueryData q ) throws LocatorException{
		return true;
	}

	public boolean applyMethod( QueryData pQ ){
		// TODO?
		return true;
	}

	Node toRecordNode(){
		Element record = new Element( "record" );
		record.appendChild( makeNode( "linkIssn", linkIssn ) );
		record.appendChild( makeNode( "linkTitle", linkTitle ) );
		record.appendChild( makeNode( "linkUrl", linkUrl) );
		record.appendChild( makeNode( "linkMethod", linkMethod ) );
		record.appendChild( makeNode( "rank", Integer.toString(rank) ) );
		record.appendChild( makeNode( "generatedUrl", generatedUrl) );
		record.appendChild( makeNode( "publisher", linkPublisher ) );
		return record;
	}

	public static Element makeNode( String tag, String value ){
		Element node = new Element( tag );
		Text txt = new Text( value );
		node.appendChild( txt );
		return node;
	}
	
	
}
